# xemacs-mule-20.4-2.spec

# Use one of these.
%define RELEASE_REQUIRE <= 4.2
#%define RELEASE_REQUIRE >= 5.0

Summary: The XEmacs editor
Name: xemacs-mule-canna-wnn6
Version: 20.4
Release: 1a
Copyright: GPL
Group: Applications/Editors/Emacs
#Packager: Stig Bjrlykke <stigb@tihlde.hist.no>
Packager: Keisuke Fujii <fujiik@jlcuxf.kek.jp>
Source0: xemacs-%{PACKAGE_VERSION}.tar.gz
Source1: xemacs-%{PACKAGE_VERSION}-info.tar.gz
Source2: xemacs-%{PACKAGE_VERSION}-mule.tar.gz
Source3: xemacs-%{PACKAGE_VERSION}-README.i386-pc-linux-mule
Source4: xemacs-%{PACKAGE_VERSION}-README.sparc-unknown-linux-mule
Source5: xemacs.wmconfig
Patch0: xemacs-%{PACKAGE_VERSION}-static.patch
Patch1: xemacs-%{PACKAGE_VERSION}-perl.patch
Patch2: xemacs-%{PACKAGE_VERSION}-ppc.patch
Url: http://www.xemacs.org/
Buildroot: /tmp/xemacs
%ifnarch ppc
Requires: redhat-release %{RELEASE_REQUIRE}
%endif
Conflicts: xemacs
#Prefix: /usr  # Can't have this with the /var/lock/xemacs directory :(

# Initially by Stig Bjrlykke <stigb@tihlde.hist.no> for i386 
# and modified for sparc by Frederic Poncin <fp@info.ucl.ac.be>
# (who can make it run correctly on alpha?)

ExclusiveArch: i386 sparc ppc

%description
XEmacs is a version of Emacs, compatible with and containing many 
improvements over FSF Emacs, written by Richard Stallman of the 
Free Software Foundation.  It was originally based on an early release 
of FSF Emacs Version 19, and has tracked subsequent releases of FSF 
Emacs as they have become available.
This XEmacs distribution has been splitted in some rpm :
- xemacs-mule-%{PACKAGE_VERSION}        : the main part
- xemacs-mule-el-%{PACKAGE_VERSION}     : elisp sources (optional)
- xemacs-mule-static-%{PACKAGE_VERSION} : statically linked xemacs (optional)
- xemacs-mule-extras-%{PACKAGE_VERSION} : files in conflict with emacs
(Install xemacs-mule-extras if you do not have emacs installed.)

%package -n xemacs-mule-el
Summary: .el source files for XEmacs
Description: .el source files -- not necessary to run XEmacs
Group: Applications/Editors/Emacs
Requires: xemacs-mule-canna-wnn6 = %{PACKAGE_VERSION}
%ifnarch ppc
Requires: redhat-release %{RELEASE_REQUIRE}
%endif

%ifnarch ppc
%package static
Summary: static linked xemacs
Description: Static linked xemacs -- independent of the libraries installed
Group: Applications/Editors/Emacs
Requires: xemacs-mule-canna-wnn6 = %{PACKAGE_VERSION}
Requires: redhat-release %{RELEASE_REQUIRE}
%endif

%package -n xemacs-mule-extras
Summary: files which conflict with FSF Emacs
Group: Applications/Editors/Emacs
Requires: xemacs-mule-canna-wnn6
%ifnarch ppc
Requires: redhat-release %{RELEASE_REQUIRE}
%endif
%description -n xemacs-mule-extras
These files are common between FSF Emacs and XEmacs. If you do not 
have FSF Emacs installed, be sure to install this package as well 
when you install XEmacs.

%changelog
* Thu Jul 16 1998 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- Rebuilt for PPC with -xfs and glibc*-1j

* Tue May 19 1998 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- PPC support

* Sun Mar  1 1998 Stig Bjorlykke <stigb@tihlde.hist.no>

- Build with MULE

* Wed Feb 25 1998 Stig Bjorlykke <stigb@tihlde.hist.no>

- Added "%RELEASE_REQUIRE".
- Build for 20.4.

* Thu Jan 15 1998 Stig Bjorlykke <stigb@tihlde.hist.no>

- Added new changelog.
- Rewrote the specfile and removed the old changelog.

%prep
%setup -T -b 0 -n xemacs-%{PACKAGE_VERSION}
%setup -T -D -b 1 -n xemacs-%{PACKAGE_VERSION}
%setup -T -D -b 2 -n xemacs-%{PACKAGE_VERSION}
%patch0 -p1
%patch1 -p0
%ifarch ppc
%patch2 -p1
# How to do this well in the patch file?
ln ppc.ldscript pkg-src/tree-x
ln ppc.ldscript src
ln ppc.ldscript lib-src
%endif

%build

%ifarch i386
%define HOSTTYPE i386-pc-linux
%define SOUND native
%endif

%ifarch sparc
%define HOSTTYPE sparc-unknown-linux
%define SOUND none
%endif

%ifarch ppc
export PATH=/usr/X11/bin:$PATH
%define HOSTTYPE ppc-unknown-linux
%define SOUND native
%endif

# Delete the originals for the patched files
find . -name "*.orig" -exec rm {} \;

#./configure %{HOSTTYPE} --with-dialogs=athena  --with-sound=%{SOUND} \
#            --cflags="$RPM_OPT_FLAGS -D_GNU_SOURCE" --error-checking=none \
#            --debug=no --prefix=/usr \
#            --with-xfs --with-mule --with-wnn6 --with-canna \
#            --site-includes='/usr/local/include /usr/local/canna/include'

./configure %{HOSTTYPE} --with-dialogs=athena  --with-sound=%{SOUND} \
            --cflags="-g -fsigned-char -D_GNU_SOURCE" --error-checking=none \
            --debug=no --prefix=/usr \
            --with-xfs --with-mule --with-wnn6 --with-canna \
            --site-includes='/usr/local/include /usr/local/canna/include'

make dist

# Static build
# (only xemacs, not the others - gnuserv, movemail, gnuclient, ...)

# First, save the result of the dynamic build
%ifnarch ppc
mv src/xemacs xemacs-dynamic
# and ask for a new build
rm src/temacs
%endif

# On sparc, ld complain about __isnan of different size in libc.a and libm.a
# so ... forget de warning :-( ... -noinhibit-exec
# See xemacs-static.patch

%ifarch i386
cd src; make temacs-static-i386; cd ..
mv src/temacs-static-i386 src/temacs
%endif

%ifarch sparc
cd src; make temacs-static-sparc; cd ..
mv src/temacs-static-sparc src/temacs
%endif

#%ifarch ppc
#cd src; make temacs-static-ppc; cd ..
#mv src/temacs-static-ppc src/temacs
#%endif

%ifnarch ppc
#xemacs generation
make
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT/usr install-arch-dep 
make prefix=$RPM_BUILD_ROOT/usr install-arch-indep 
make prefix=$RPM_BUILD_ROOT/usr gzip-el 

%ifnarch ppc
mv $RPM_BUILD_ROOT/usr/bin/xemacs-%{PACKAGE_VERSION} \
   $RPM_BUILD_ROOT/usr/bin/xemacs-static
install -c -m755 xemacs-dynamic \
   $RPM_BUILD_ROOT/usr/bin/xemacs-%{PACKAGE_VERSION}
%endif

%ifarch ppc
ln -s ppc-unknown-linux \
	$RPM_BUILD_ROOT/usr/lib/xemacs-%{PACKAGE_VERSION}/powerpc-unknown-linux
%endif

%ifnarch ppc
cp $RPM_SOURCE_DIR/xemacs-%{PACKAGE_VERSION}-README.%{HOSTTYPE} \
   README.%{HOSTTYPE}
%endif
cp $RPM_SOURCE_DIR/xemacs-%{PACKAGE_VERSION}-static.patch xemacs-static.patch
mkdir -p -m 0777 $RPM_BUILD_ROOT/var/lock/xemacs

# Build file listings. (and make movemail setgid mail on RHL)

DIR="$RPM_BUILD_ROOT/usr/lib/xemacs-%{PACKAGE_VERSION}"
EL="*.el.gz"

find $DIR -type d |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %dir #" > rpm-files

find $DIR -name $EL -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #" > rpm-el-files

find $DIR -not -name $EL -type f |
  sed -e "
    s#^$RPM_BUILD_ROOT\(.*movemail\)#%attr(2755, root, mail) \1#
    s#^$RPM_BUILD_ROOT#%attr(-, root, root) #
  " >> rpm-files

%ifarch ppc
echo /usr/lib/xemacs-%{PACKAGE_VERSION}/powerpc-unknown-linux \
	>> rpm-files
%endif

# Include wmconfig file if RedHat 5.0 or greater.

%ifnarch ppc 
if [ "%{RELEASE_REQUIRE}" = ">= 5.0" ]; then
  mkdir -p -m 755 $RPM_BUILD_ROOT/etc/X11/wmconfig
  cp $RPM_SOURCE_DIR/xemacs.wmconfig $RPM_BUILD_ROOT/etc/X11/wmconfig/xemacs
  echo "%attr(-, root, root) %config /etc/X11/wmconfig/xemacs" >> rpm-files
fi
%endif

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%attr(-, root, root) %doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS 
%ifnarch ppc
%attr(-, root, root) %doc etc/NEWS etc/MAILINGLISTS BUGS README.%{HOSTTYPE}
%else
%attr(-, root, root) %doc etc/NEWS etc/MAILINGLISTS BUGS README*
%endif
%attr(-, root, root) %doc Installation xemacs-static.patch
%attr(-, root, root) /usr/bin/xemacs
%attr(-, root, root) /usr/bin/xemacs-%{PACKAGE_VERSION}
%attr(-, root, root) /usr/bin/pstogif
%attr(-, root, root) /usr/bin/install-sid
%attr(-, root, root) /usr/bin/send-pr
%attr(-, root, root) /usr/bin/gnuclient
%attr(-, root, root) /usr/bin/gnuattach
%attr(-, root, root) /usr/bin/gnudoit
%attr(-, root, root) /usr/man/man1/xemacs.1
%attr(-, root, root) /usr/man/man1/gnuserv.1
%attr(-, root, root) /usr/man/man1/gnuclient.1
%attr(-, root, root) /usr/man/man1/gnuattach.1
%attr(-, root, root) /usr/man/man1/gnudoit.1
%attr(-, root, root) %dir /usr/lib/xemacs/
%attr(-, root, root) %dir /usr/lib/xemacs/site-lisp
%attr(-, root, root) %dir /var/lock/xemacs
%files -f rpm-files

%files -n xemacs-mule-el -f rpm-el-files

%files -n xemacs-mule-extras
%attr(-, root, root) /usr/bin/b2m
%attr(-, root, root) /usr/bin/ctags
%attr(-, root, root) /usr/bin/etags
%attr(-, root, root) /usr/bin/rcs-checkin
%attr(-, root, root) /usr/man/man1/ctags.1
%attr(-, root, root) /usr/man/man1/etags.1

%ifnarch ppc
%files static
%attr(-, root, root) /usr/bin/xemacs-static
%endif

# eof
